local handler = require("event_handler")
handler.add_lib(require("freeplay"))
handler.add_lib(require("silo-script"))


local event_handler = require("event_handler")
local json = require ("dependencies/dkjson")
local output = {}
local JSONoutput=""

function getproduseditemcount(item)
    return game.players[1].force.item_production_statistics.input_counts[item] -- fails here
end
function getconsumeditemcount(item)
    return game.players[1].force.item_production_statistics.output_counts[item] -- and fails here
end

function itemsToJSON()
    time=math.floor(game.tick/216000)..":"..math.floor((game.tick/3600)%60)..":"..math.floor((game.tick/60)%60+0.5)
    research=""    
    if(game.players[1].force.current_research) then
        research = game.players[1].force.current_research
    else
        research = "none"
    end
    red_science={produced=getproduseditemcount("automation-science-pack"), consumed=getconsumeditemcount("automation-science-pack")}
    green_science={produced=getproduseditemcount("logistic-science-pack"), consumed=getconsumeditemcount("logistic-science-pack")}
    blue_science={produced=getproduseditemcount("chemical-science-pack"), consumed=getconsumeditemcount("chemical-science-pack")}
    purple_science={produced=getproduseditemcount("production-science-pack"), consumed=getconsumeditemcount("production-science-pack")}
    yellow_science={produced=getproduseditemcount("utility-science-pack"), consumed=getconsumeditemcount("utility-science-pack")}
    table.insert(output,{time=time, research=research, red_science=red_science, green_science=green_science, blue_science=blue_science, purple_science=purple_science, yellow_science=yellow_science})
end


function update()
    if game.tick%3600==0 then
        itemsToJSON()
    end
    if game.tick>=(0*3600+20*60)*60 then
      JSONoutput=json.encode(output, { indent = true })
      game.write_file("JSONoutput.json",JSONoutput)
      game.print("writing file is done") -- its on purpose that it fails here
    end
end


event_handler.add_lib({
    events = {
        [defines.events.on_tick] = update
    },
})
